/***********************************************
 *
 * OG Script Dumper v5.0 by learn_more
 * File: out\a205\script\cam_dump.as
 * Generated: 03-Feb-2014 00:58:10
 * Overgrowth.exe base: 0x13e0000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// cam.as


/***********************************************
 * Global Functions:
 */

vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x2d48b0 (0x16b48b0)


/***********************************************
 * Objects:
 */

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0x2d5770 (0x16b5770)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0x2d4d40 (0x16b4d40)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x2d4fa0 (0x16b4fa0)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x2d4740 (0x16b4740)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x2d4580 (0x16b4580)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x2d45d0 (0x16b45d0)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x2d46f0 (0x16b46f0)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x2d4540 (0x16b4540)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x2d4830 (0x16b4830)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x2d4880 (0x16b4880)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x2d47d0 (0x16b47d0)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x2d4770 (0x16b4770)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x2d4440 (0x16b4440)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x2d4e70 (0x16b4e70)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x2e0970 (0x16c0970)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x2e5e00 (0x16c5e00)
	void RemoveAll();		// 'Overgrowth.exe' + 0x2e5da0 (0x16c5da0)
	void Execute(uint32, string);		// 'Overgrowth.exe' + 0x2e4eb0 (0x16c4eb0)
	void MoveTo(uint32, int, int);		// 'Overgrowth.exe' + 0x2e5b90 (0x16c5b90)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x2e50c0 (0x16c50c0)
	void Update();		// 'Overgrowth.exe' + 0x2e6060 (0x16c6060)
};

class CameraObject
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 position;		// byteOffset: 0x5c
	bool controlled;		// byteOffset: 0x88
	bool frozen;		// byteOffset: 0xac
	vec3 velocity;		// byteOffset: 0xb0
	bool ignore_mouse_input;		// byteOffset: 0xc0
//-----
	void LoadParallaxScene(string, string);		// 'Overgrowth.exe' + 0x23a9f0 (0x161a9f0)
	void UnloadParallaxScene();		// 'Overgrowth.exe' + 0x23aa90 (0x161aa90)
};

class CameraAnimationReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void AttachTo(string);		// 'Overgrowth.exe' + 0xef8a0 (0x14cf8a0)
	vec3 GetPosition();		// 'Overgrowth.exe' + 0xf00d0 (0x14d00d0)
	vec4 GetRotationVec4();		// 'Overgrowth.exe' + 0xf0610 (0x14d0610)
	float GetLens();		// 'Overgrowth.exe' + 0xeff00 (0x14cff00)
	void Update();		// 'Overgrowth.exe' + 0xf0db0 (0x14d0db0)
	bool valid();		// 'Overgrowth.exe' + 0xf3c70 (0x14d3c70)
};



/***********************************************
 * Global Properties:
 */

ASCollisions col;		// 0x2e345800
SphereCollision sphere_col;		// 0x2e345804
GUI gui;		// 0x2e348ee0
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x594b30 (0x1974b30)
CameraObject co;		// 0x1dfee3b8
CameraAnimationReader camera_animation_reader;		// 0x1dfee47c
