/***********************************************
 *
 * OG Script Dumper v5.0 by learn_more
 * File: out\a205\script\challengelevel_dump.as
 * Generated: 03-Feb-2014 00:58:10
 * Overgrowth.exe base: 0x13e0000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// challengelevel.as
	// ui_effects.as
	// threatcheck.as


/***********************************************
 * Enums:
 */

enum UIState
{
	kNothing = 0,
	kHot = 1,
	kActive = 2,
};

enum EntityType
{
	_env_object = 20,
	_decal_object = 24,
	_item_object = 32,
	_movement_object = 21,
	_hotspot_object = 26,
	_placeholder_object = 35,
	_path_point_object = 33,
};

enum AttachmentType
{
	_at_attachment = 2,
	_at_grip = 0,
	_at_sheathe = 1,
	_at_unspecified = 3,
};

enum PlaceholderObjectType
{
	kCamPreview = 1,
	kPlayerConnect = 2,
	kSpawn = 0,
};



/***********************************************
 * Global Functions:
 */

void __cdecl DisplayError(const string &in title, const string &in contents)			// 'Overgrowth.exe' + 0x2dc800 (0x16bc800)
void __cdecl SendMessage(int, int, vec3, vec3)			// 'Overgrowth.exe' + 0x2df320 (0x16bf320)
void __cdecl SendMessage(int, string)			// 'Overgrowth.exe' + 0x2df4b0 (0x16bf4b0)
void __cdecl PrintCallstack()			// 'Overgrowth.exe' + 0x2de260 (0x16be260)
float __cdecl atof(const string &in str)			// 'Overgrowth.exe' + 0x2e0870 (0x16c0870)
int __cdecl atoi(const string &in str)			// 'Overgrowth.exe' + 0x2e0890 (0x16c0890)
Object@ __cdecl ReadObjectFromID(int)			// 'Overgrowth.exe' + 0x2e5c30 (0x16c5c30)
bool __cdecl ObjectExists()			// 'Overgrowth.exe' + 0x2e5bf0 (0x16c5bf0)
array<int> __cdecl @GetObjectIDs()			// 'Overgrowth.exe' + 0x2dd0f0 (0x16bd0f0)
array<int> __cdecl @GetObjectIDsType(int)			// 'Overgrowth.exe' + 0x2dd1d0 (0x16bd1d0)
void __cdecl DeleteObjectID(int)			// 'Overgrowth.exe' + 0x2dc700 (0x16bc700)
int __cdecl CreateObject(const string &in path)			// 'Overgrowth.exe' + 0x2dbfc0 (0x16bbfc0)
int __cdecl DuplicateObject(Object@ obj)			// 'Overgrowth.exe' + 0x2dcd60 (0x16bcd60)
void __cdecl DeselectAll()			// 'Overgrowth.exe' + 0x2dc780 (0x16bc780)
void __cdecl Breakpoint(int)			// 'Overgrowth.exe' + 0x2e4e50 (0x16c4e50)
bool __cdecl LoadFile(const string &in)			// 'Overgrowth.exe' + 0x2dd510 (0x16bd510)
string __cdecl GetFileLine()			// 'Overgrowth.exe' + 0x2dceb0 (0x16bceb0)
void __cdecl StartWriteFile()			// 'Overgrowth.exe' + 0x2dfa90 (0x16bfa90)
void __cdecl AddFileString(const string &in)			// 'Overgrowth.exe' + 0x2dbde0 (0x16bbde0)
bool __cdecl WriteFile(const string &in)			// 'Overgrowth.exe' + 0x2dfd30 (0x16bfd30)
void __cdecl OpenSettings()			// 'Overgrowth.exe' + 0x200080 (0x15e0080)


/***********************************************
 * Objects:
 */

class IMUIContext
{		// size: 0x24, flags:  asOBJ_VALUE asOBJ_POD
	void UpdateControls();		// 'Overgrowth.exe' + 0x1ed380 (0x15cd380)
	bool DoButton(int, vec2, vec2, UIState &out);		// 'Overgrowth.exe' + 0x1ecce0 (0x15ccce0)
	void Init();		// 'Overgrowth.exe' + 0x1ed330 (0x15cd330)
};

class Object
{		// size: 0x0, flags:  asOBJ_REF
	PlaceholderObject@ f();		// 'Overgrowth.exe' + 0x2db7a0 (0x16bb7a0)(asBEHAVE_REF_CAST,asCALL_CDECL_OBJLAST,global func)
//-----
	int GetID();		// 'Overgrowth.exe' + 0x3d870 (0x141d870)
	bool IsSelected();		// 'Overgrowth.exe' + 0x2dd500 (0x16bd500)(asCALL_CDECL_OBJFIRST,global func)
	void SetSelected(bool);		// 'Overgrowth.exe' + 0x2df870 (0x16bf870)(asCALL_CDECL_OBJFIRST,global func)
	void SetTranslation(const vec3 &in);		// 'Overgrowth.exe' + 0x2df9c0 (0x16bf9c0)(asCALL_CDECL_OBJFIRST,global func)
	vec3 GetTranslation();		// 'Overgrowth.exe' + 0x2dd4a0 (0x16bd4a0)(asCALL_CDECL_OBJFIRST,global func)
	void SetScale(const vec3 &in);		// 'Overgrowth.exe' + 0x2df800 (0x16bf800)(asCALL_CDECL_OBJFIRST,global func)
	vec3 GetScale();		// 'Overgrowth.exe' + 0x2dd470 (0x16bd470)(asCALL_CDECL_OBJFIRST,global func)
	void SetRotation(const quaternion &in);		// 'Overgrowth.exe' + 0x2df700 (0x16bf700)(asCALL_CDECL_OBJFIRST,global func)
	quaternion GetRotation();		// 'Overgrowth.exe' + 0x2dd390 (0x16bd390)(asCALL_CDECL_OBJFIRST,global func)
	vec4 GetRotationVec4();		// 'Overgrowth.exe' + 0x2dd400 (0x16bd400)(asCALL_CDECL_OBJFIRST,global func)
	EntityType GetType();		// 'Overgrowth.exe' + 0x2dd4f0 (0x16bd4f0)(asCALL_CDECL_OBJFIRST,global func)
	void SetPlayer(bool);		// 'Overgrowth.exe' + 0x2df6c0 (0x16bf6c0)(asCALL_CDECL_OBJFIRST,global func)
	int GetNumPaletteColors();		// 'Overgrowth.exe' + 0x2dd0c0 (0x16bd0c0)(asCALL_CDECL_OBJFIRST,global func)
	vec3 GetPaletteColor(int);		// 'Overgrowth.exe' + 0x2e5500 (0x16c5500)(asCALL_CDECL_OBJFIRST,global func)
	void SetPaletteColor(int, const vec3 &in);		// 'Overgrowth.exe' + 0x2e5f00 (0x16c5f00)(asCALL_CDECL_OBJFIRST,global func)
	vec3 GetTint();		// 'Overgrowth.exe' + 0x2e56e0 (0x16c56e0)(asCALL_CDECL_OBJFIRST,global func)
	void SetTint(const vec3 &in);		// 'Overgrowth.exe' + 0x2e5fa0 (0x16c5fa0)(asCALL_CDECL_OBJFIRST,global func)
	void ConnectTo(Object@);		// 'Overgrowth.exe' + 0x2e4e90 (0x16c4e90)(asCALL_CDECL_OBJFIRST,global func)
	void AttachItem(Object@, AttachmentType, bool);		// 'Overgrowth.exe' + 0x2e1660 (0x16c1660)(asCALL_CDECL_OBJFIRST,global func)
	void ReceiveScriptMessage(const string &in);		// 'Overgrowth.exe' + 0x26f700 (0x164f700)
	void UpdateScriptParams();		// 'Overgrowth.exe' + 0x2dfd20 (0x16bfd20)(asCALL_CDECL_OBJFIRST,global func)
	void SetCopyable(bool);		// 'Overgrowth.exe' + 0x2df5f0 (0x16bf5f0)(asCALL_CDECL_OBJFIRST,global func)
	void SetDeletable(bool);		// 'Overgrowth.exe' + 0x2df610 (0x16bf610)(asCALL_CDECL_OBJFIRST,global func)
	void SetScalable(bool);		// 'Overgrowth.exe' + 0x2df7e0 (0x16bf7e0)(asCALL_CDECL_OBJFIRST,global func)
	void SetTranslatable(bool);		// 'Overgrowth.exe' + 0x2df9a0 (0x16bf9a0)(asCALL_CDECL_OBJFIRST,global func)
	void SetRotatable(bool);		// 'Overgrowth.exe' + 0x2df6e0 (0x16bf6e0)(asCALL_CDECL_OBJFIRST,global func)
	ScriptParams@ GetScriptParams();		// 'Overgrowth.exe' + 0x2e5660 (0x16c5660)(asCALL_CDECL_OBJFIRST,global func)
};

class PlaceholderObject
{		// size: 0x0, flags:  asOBJ_REF
	void SetPreview(const string &in);		// 'Overgrowth.exe' + 0x273c90 (0x1653c90)
	void SetBillboard(const string &in);		// 'Overgrowth.exe' + 0x273a20 (0x1653a20)
	void SetSpecialType(int);		// 'Overgrowth.exe' + 0x273eb0 (0x1653eb0)
	int GetConnectID();		// 'Overgrowth.exe' + 0x2738f0 (0x16538f0)
};

class TokenIterator
{		// size: 0xc, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	void Init();		// 'Overgrowth.exe' + 0x2e58b0 (0x16c58b0)
	bool FindNextToken(const string& in);		// 'Overgrowth.exe' + 0x2e4f20 (0x16c4f20)
	string GetToken(const string& in);		// 'Overgrowth.exe' + 0x2e5740 (0x16c5740)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x2e0970 (0x16c0970)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x2e5e00 (0x16c5e00)
	void RemoveAll();		// 'Overgrowth.exe' + 0x2e5da0 (0x16c5da0)
	void Execute(uint32, string);		// 'Overgrowth.exe' + 0x2e4eb0 (0x16c4eb0)
	void MoveTo(uint32, int, int);		// 'Overgrowth.exe' + 0x2e5b90 (0x16c5b90)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x2e50c0 (0x16c50c0)
	void Update();		// 'Overgrowth.exe' + 0x2e6060 (0x16c6060)
};

class HUDImage
{		// size: 0x0, flags:  asOBJ_REF
	vec3 position;		// byteOffset: 0x4
	vec3 scale;		// byteOffset: 0x10
	vec2 tex_scale;		// byteOffset: 0x1c
	vec2 tex_offset;		// byteOffset: 0x24
	vec4 color;		// byteOffset: 0x2c
//-----
	float GetWidth() const;		// 'Overgrowth.exe' + 0x128250 (0x1508250)
	float GetHeight() const;		// 'Overgrowth.exe' + 0x128180 (0x1508180)
	void SetImageFromPath(const string &in);		// 'Overgrowth.exe' + 0x128320 (0x1508320)
	void SetImageFromText(const TextCanvasTexture@);		// 'Overgrowth.exe' + 0x1283d0 (0x15083d0)
};

class HUDImages
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	HUDImage@ AddImage();		// 'Overgrowth.exe' + 0x1278f0 (0x15078f0)
};

class SavedLevel
{		// size: 0x0, flags:  asOBJ_REF
	void SetValue(const string &in key, const string &in value);		// 'Overgrowth.exe' + 0xa76f0 (0x14876f0)
	const string& GetValue(const string &in key);		// 'Overgrowth.exe' + 0xa6f70 (0x1486f70)
};

class SaveFile
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	SavedLevel& GetSavedLevel(const string &in name);		// 'Overgrowth.exe' + 0xa6f30 (0x1486f30)
	bool WriteInPlace();		// 'Overgrowth.exe' + 0xa7730 (0x1487730)
};



/***********************************************
 * Global Properties:
 */

int _plant_movement_msg;		// 'Overgrowth.exe' + 0x594b34 (0x1974b34)
int _editor_msg;		// 'Overgrowth.exe' + 0x594b40 (0x1974b40)
GUI gui;		// 0x367ee610
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x594b30 (0x1974b30)
HUDImages hud;		// 'Overgrowth.exe' + 0x638900 (0x1a18900)
SaveFile save_file;		// 0x36695208
